# Class SubjectDomainCombiner

java.lang.Object
javax.security.auth.SubjectDomainCombiner

All Implemented Interfaces:
  `DomainCombiner`

@Deprecated(since="17", forRemoval=true) public class SubjectDomainCombiner extends Object implements DomainCombiner
Deprecated, for removal: This API element is subject to removal in a future version.
This class was only useful in conjunction with the Security Manager, which is no longer supported. There is no replacement for the Security Manager or this class.
SubjectDomainCombiner was used to dynamically update ProtectionDomains with Principals for access control operations and decisions. This feature no longer exists.

Since:
  1.4

## Constructor Summary

Constructors
Constructor
Description
`SubjectDomainCombiner(Subject subject)`
Deprecated, for removal: This API element is subject to removal in a future version.
Associate the provided `Subject` with this `SubjectDomainCombiner`.

## Method Summary

Modifier and Type
Method
Description
`ProtectionDomain[]`
`combine(ProtectionDomain[] currentDomains, ProtectionDomain[] assignedDomains)`
Deprecated, for removal: This API element is subject to removal in a future version.
Update the relevant ProtectionDomains with the Principals from the `Subject` associated with this `SubjectDomainCombiner`.
`Subject`
`getSubject()`
Deprecated, for removal: This API element is subject to removal in a future version.
Get the `Subject` associated with this `SubjectDomainCombiner`.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### SubjectDomainCombiner

public SubjectDomainCombiner(Subject subject)
Deprecated, for removal: This API element is subject to removal in a future version.
Associate the provided `Subject` with this `SubjectDomainCombiner`.

Parameters:
  `subject` - the `Subject` to be associated with this `SubjectDomainCombiner`.

## Method Details

### getSubject

public Subject getSubject()
Deprecated, for removal: This API element is subject to removal in a future version.
Get the `Subject` associated with this `SubjectDomainCombiner`.

Returns:
  the `Subject` associated with this `SubjectDomainCombiner`, or `null` if no `Subject` is associated with this `SubjectDomainCombiner`.

### combine

public ProtectionDomain[] combine(ProtectionDomain[] currentDomains, ProtectionDomain[] assignedDomains)
Deprecated, for removal: This API element is subject to removal in a future version.
Update the relevant ProtectionDomains with the Principals from the `Subject` associated with this `SubjectDomainCombiner`.

A new `ProtectionDomain` instance is created for each non-static `ProtectionDomain` ( (staticPermissionsOnly() == false) in the `currentDomains` array. Each new `ProtectionDomain` instance is created using the `CodeSource`, `Permission`s and `ClassLoader` from the corresponding `ProtectionDomain` in `currentDomains`, as well as with the Principals from the `Subject` associated with this `SubjectDomainCombiner`. Static ProtectionDomains are combined as-is and no new instance is created.

All of the ProtectionDomains (static and newly instantiated) are combined into a new array. The ProtectionDomains from the `assignedDomains` array are appended to this new array, and the result is returned.

Note that optimizations such as the removal of duplicate ProtectionDomains may have occurred. In addition, caching of ProtectionDomains may be permitted.

Specified by:
  `combine` in interface `DomainCombiner`
Parameters:
  `currentDomains` - the ProtectionDomains associated with the current execution Thread. The ProtectionDomains are listed in order of execution, with the most recently executing `ProtectionDomain` residing at the beginning of the array. This parameter may be `null` if the current execution Thread has no associated ProtectionDomains.
  `assignedDomains` - the inherited ProtectionDomains. This parameter may be `null` if there were no inherited ProtectionDomains.
Returns:
  a new array consisting of the updated ProtectionDomains, or `null`.